FFmpeg in Vewd Core
===================

See README.chromium for the general Chromium-POV description. In short,
Chromium uses a set of pre-generated FFmpeg configurations that the build
can choose with the 'ffmpeg_branding' gn switch. There is a set of scripts
to regenerate the configurations when upgrading FFmpeg, or when a config
change is needed. Vewd Core follows that setup with a few patches and tweaks.

Vewd Core uses a separate set of configurations from the existing
Chrome/ChromeOS/Chromium set. These are:
 * TVSDK: the default config with few decoders and mostly just parsers,
   to be used on devices)
 * TVSDK_SW: the mostly-all-codecs config used for playback on x86_64
Note that the Android versions of the configs may differ slightly from Linux.

The separate configuration instead of patching existing configs allows some
flexibility in debugging. It is possible to run an x86_64 build with a
device-like FFmpeg configuration by setting `ffmpeg_branding=\"TVSDK\"` in gn,
or try a device build with mostly-all codecs by doing the corresponding
`ffmpeg_branding=\"TVSDK_SW\"`.

The setup is built around several separate TVCHR patches. The main thing to
note is that the generated changes are kept as a separate patch from manual
changes to or around the config generators. In other words while "TVCHR-901:
TVSDK-26564: Add custom ffmpeg gni generator" and "TVCHR-927: TVSDK changes
to chromium ffmpeg gn build"  and minor bugfix/tweak patches are manual, thre
is one patch, "TVCHR-915: Generate FFmpeg configuration" that is always
completely generated and should not have any manual tweaks.

The procdeure to change FFmpeg configuration is to generally:
1. Push a review for a fixup in the generator script (TVCHR-901)
2. Get that change accepted and land it.
3. Regenerate the configuration with chromium/scripts/generate_tvsdk_ffmpeg.sh
4. Push all resulting changes as review -- fixup to TVCHR-915
5. Land the new config.

It is recommended to test things locally before doing 1/2.

See https://jenkins-legacy.corp.vewd.com/job/util/job/sdk4-ffmpeg/ for a
mostly automated way of performing the config regenaration steps.
